<?php
  // Avoid loading this class directly from browser
  if (preg_match("/.class.php/i", $_SERVER['PHP_SELF']))
  {
    echo "<html>\r\n<head>\r\n<title>Forbidden 403</title>\r\n</head>\r\n<body><h3>Forbidden 403</h3>\r\nThe document you are requesting is forbidden.\r\n</body>\r\n</html>";
    exit;
  }

 /***********************************************
    captcha.class.php
  ***********************************************
    ver. 1.1
  ***********************************************
    Created by Safa Rimeh and Yasen Georgiev
    http://www.yasbas.com/freelance
                  ***
    For integration support or features
    request, please contact us: malemsoft@gmail.com
 ***********************************************/

class Captcha
{
    // Private variables for class internal usage only
    var $_sessionName;
    var $_imageType;
    var $_captchaId;
    var  $_params;


    // The array which holds the default captcha options values. You can set the default options here.
    var $_defaultValues = array
    (
            'font'             => 'fonts/bebas.ttf',               // The path to the font used in the captcha.
            'font_size'        => 20,                              // The size of the font.
            'font_color'       => array(0, 0, 0),                  // RGB color in array, equals to RGB(0, 0, 0), which is black color.
            'text_length'      => 4,                               // The captcha text characters count
            'captcha_size'     => array(80, 50),                   // The size of the captcha image  (width, height)
            'shadow_color'     => array(240, 240, 240),            // The captcha text shadow color in RGB format, like: array(255, 138, 164)
            'background_color' => array(255, 255, 255),            // The captcha image background color in RGB format
            'background_image' => 'images/bg1.jpg',                // The captcha background images that will show random, like array('images/1.jpg', array('images/2.jpg', array('images/3.jpg')
            'text_offset'      => array(10, 37),                   // The captcha text top-left corner coordinates (x, y)
            'angle'            => 8,                               // The angle that the captcha text will be rotaed, it's in range from -360 to 360
            'image_filter'     => false,                           // Use image filter to further disort the captcha and confuse the bots
            'maptcha'           => false,                           // Use maptcha. e.g: 5+5 = 10
            /////////////////////////////////////////////////////////////////////////////////
            'captcha_text'     => '',                               // DO NOT EDIT this option
            'captcha_value'    => '',                               // DO NOT EDIT this option
    );

  //Handle php4 rubbish
    function Captcha($params){
      return $this->__construct($params);
    }

    function __construct($params)
    {
        $this->_sessionName='';
        $this->_initParams();
        $this->_captchaId = $params['captcha_id'];

        // Came from captcha.php (loading captcha)
        if (isset($params['ismd5']) && $params['ismd5'])
        {
            $this->_sessionName = md5('@hMYyS&*7907PO~^lk').$this->_captchaId;
            $this->_setParams($_SESSION[$this->_sessionName]);
        }
        // Came from other page (creating new captcha)
        else
        {
            $this->_sessionName = md5('@hMYyS&*7907PO~^lk').md5($this->_captchaId);
            if (!isset($_SESSION[$this->_sessionName]['captcha_text']))
            {
                $_SESSION[$this->_sessionName] = $params;
                $this->_setParams($params);
            }
            else
            {
                $this->_setParams($params);
                $this->_params['captcha_text'] = $_SESSION[$this->_sessionName]['captcha_text'];
                $this->_params['captcha_value'] = $_SESSION[$this->_sessionName]['captcha_value'];
                $_SESSION[$this->_sessionName] = $this->_params;
            }
        }

        if (! isset($_SESSION[$this->_sessionName]['captcha_text']))
        {
            $this->generateCaptchaCode();
        }
    }

     function _initParams()
    {
        $this->_params = array(
            'font'             => $this->_defaultValues['font'],
            'font_size'        => $this->_defaultValues['font_size'],
            'font_color'       => $this->_defaultValues['font_color'],
            'text_length'      => $this->_defaultValues['text_length'],
            'captcha_size'     => $this->_defaultValues['captcha_size'],
            'shadow_color'     => $this->_defaultValues['shadow_color'],
            'background_color' => $this->_defaultValues['background_color'],
            'background_image' => $this->_defaultValues['background_image'],
            'text_offset'      => $this->_defaultValues['text_offset'],
            'angle'            => $this->_defaultValues['angle'],
            'image_filter'     => $this->_defaultValues['image_filter'],
            'maptcha'           => $this->_defaultValues['maptcha'],
            ///////////////////////////////////////////////////
            'captcha_text'     => '', // DO NOT EDIT this option
            'captcha_value'     => '' // DO NOT EDIT this option
        );
    }

    function _setParams($params)
    {
        if( is_array($params))
        {
            foreach($params as $key => $value)
            {
                if(array_key_exists($key, $this->_params))
                {
                    $this->_params[$key] = $value;
                }
            }
        }
    }

    function show()
    {
        $offsetText = $this->_getOffsetText();

        // Create the captcha image background, according to optios set.
        $image = $this->_getBackgroundImage();
        // Draw captcha shadow, if set
        if ($this->_getShadowColor())
        {
            imagettftext($image, $this->_getFontSize(), $this->_getAngle(), $offsetText["x"] + 1, $offsetText["y"] + 1, $this->_getShadowColor(), $this->_getFont(), $this->_params['captcha_text']);
        }
        // Draw the final captcha image
        imagettftext($image, $this->_getFontSize(), $this->_getAngle(), $offsetText["x"], $offsetText["y"], $this->_getFontColor(), $this->_getFont(), $this->_params['captcha_text']);
        // Distort the image with pre-made filter, if set
        if (isset($this->_params['image_filter']) && $this->_params['image_filter'])
        {
            imagefilter($image, IMG_FILTER_MEAN_REMOVAL);
            //imagefilter($image, IMG_FILTER_EDGEDETECT);
            //imagefilter($image, IMG_FILTER_EMBOSS);
            //imagefilter($image, IMG_FILTER_GAUSSIAN_BLUR);
            //imagefilter($image, IMG_FILTER_MEAN_REMOVAL);
        }

        // Send image content-type header
        header ('Content-type: ' . $this->_imageType["mime"]);
        // Producing the captcha image in the same format as the background image, if a background image is set. Otherwise it will create PNG image
        switch ($this->_imageType[2])
        {
              case 1:
                 @imagegif($image);
                 break;
              case 2:
                 @imagejpeg($image);
                 break;
              case 3:
                 @imagepng($image);
                 break;
              case 15:
                 @imagewbmp($image);
                 break;

              default:
                 @imagepng($image);
                 break;
        }
        // Release the resources
        imagedestroy($image);
        exit;
    }

    function validate($value)
    {
        return (sha1(strtolower($value)) == sha1(strtolower($this->_params['captcha_text']))) ||
               (sha1(strtolower($value)) == sha1(strtolower($this->_params['captcha_value'])));
    }

    function kill()
    {
        unset($_SESSION[$this->_sessionName]);
    }

    function getCaptchaUrl($url)
    {
        if (isset($this->_params['ismd5']) && $this->_params['ismd5'])
        {
            return $url . '?sycid='.$this->_captchaId;
        }
        else
        {
            return $url . '?sycid='.md5($this->_captchaId);
        }
    }

    function generateCaptchaCode()
    {
        $text = '';
        $value = '';

        if ($this->_params['maptcha'])
        {
            $signArray = array(0 => '+', 1 => '-');
            $sign = $signArray[rand(0, count($signArray) - 1)];

            do{
                $num1 = rand(1, 10);
                $num2 = rand(1, 10);

            } while ($num1 === $num2);

            $formula = max($num1, $num2) . $sign . min($num1, $num2); //Symbol '.' is not avalible in eval()!!!!
            $value = eval("return {$formula};");

            $text    = max($num1, $num2) . ' ' . $sign . ' ' . min($num1, $num2);

        } else {
                $randstr = md5(time());

                for( $i = 0; $i < $this->_getTextLength(); $i++)
                {
                    $text .= substr($randstr, rand(0, strlen($randstr) -1 ), 1);
                }

                $value = $text;
        }

        $this->_params['captcha_text'] = $text;
        $this->_params['captcha_value'] = $value;
        $_SESSION[$this->_sessionName]['captcha_text'] = $text;
        $_SESSION[$this->_sessionName]['captcha_value'] = $value;
    }

    function getImageSize()
    {
        if (isset($this->_params["captcha_size"]) && isset($this->_params["captcha_size"][0]) && is_numeric($this->_params["captcha_size"][0]) &&
            isset($this->_params["captcha_size"][1]) && is_numeric($this->_params["captcha_size"][1])
           )
        {
            $size["width"]  = ((integer) $this->_params["captcha_size"][0]) > 0 ? $this->_params["captcha_size"][0] : $this->_defaultValues['captcha_size'][0];
            $size["height"] = ((integer) $this->_params["captcha_size"][1]) > 0 ? $this->_params["captcha_size"][1] : $this->_defaultValues['captcha_size'][1];
        }
        else
        {
            $size["width"]   = $this->_defaultValues['captcha_size'][0];
            $size["height"]  = $this->_defaultValues['captcha_size'][1];
        }
         return $size;
    }

    function _getAngle()
    {
       return  (integer) (is_numeric($this->_params['angle']) ? $this->_params['angle'] : $this->_defaultValues['angle']);
    }

    function _getFontSize()
    {
       return ((integer) $this->_params['font_size']) ? $this->_params['font_size'] : $this->_defaultValues['font_size'];
    }

    function _getBackgroundColor()
    {
        $red   = ((integer) $this->_params['background_color'][0]) ? $this->_params['background_color'][0] : $this->_defaultValues['background_color'][0];
        $green = ((integer) $this->_params['background_color'][1]) ? $this->_params['background_color'][1] : $this->_defaultValues['background_color'][1];
        $blue  = ((integer) $this->_params['background_color'][2]) ? $this->_params['background_color'][2] : $this->_defaultValues['background_color'][2];

        return imagecolorallocate(imagecreatetruecolor(1, 1), $red, $green, $blue);
    }

    function _getFontColor()
    {
        $red   = ((integer) $this->_params['font_color'][0]) ? $this->_params['font_color'][0] : $this->_defaultValues['font_color'][0];
        $green = ((integer) $this->_params['font_color'][1]) ? $this->_params['font_color'][1] : $this->_defaultValues['font_color'][1];
        $blue  = ((integer) $this->_params['font_color'][2]) ? $this->_params['font_color'][2] : $this->_defaultValues['font_color'][2];

        return imagecolorallocate(imagecreatetruecolor(1, 1), $red, $green, $blue);
    }

    function _getShadowColor()
    {
        $color = false;

        if (isset($this->_params['shadow_color']) && is_array($this->_params['shadow_color']))
        {
                $red   = ((integer) $this->_params['shadow_color'][0]) ? $this->_params['shadow_color'][0] : $this->_defaultValues['shadow_color'][0];
                $green = ((integer) $this->_params['shadow_color'][1]) ? $this->_params['shadow_color'][1] : $this->_defaultValues['shadow_color'][1];
                $blue  = ((integer) $this->_params['shadow_color'][2]) ? $this->_params['shadow_color'][2] : $this->_defaultValues['shadow_color'][2];

                $color = imagecolorallocate(imagecreatetruecolor(1, 1), $red, $green, $blue);
        }

        return $color;
    }

    function _getOffsetText()
    {
        $offset['x'] = ((integer) $this->_params['text_offset'][0]) ? $this->_params['text_offset'][0] : $this->_defaultValues['text_offset'][0];
        $offset['y'] = ((integer) $this->_params['text_offset'][1]) ? $this->_params['text_offset'][1] : $this->_defaultValues['text_offset'][1];

        return $offset;
    }

    function _getFont()
    {
        return isset($this->_params['font']) ? $this->_params['font'] : $this->_defaultValues['font'];
    }

    function _getBackgroundImage()
    {
        $img = false;
        $image_array = $this->_params['background_image'];

        if (! empty($image_array))
        {
             $value = $image_array[rand(0, count($image_array) -1)];

             $imageType = @getimagesize($value);
        }

        if (ISSET($imageType) && $imageType <> null)
        {
            $this->_imageType = $imageType;

            switch ($this->_imageType[2])
            {
                  case 1:
                     $img = @imagecreatefromgif($value);
                     break;

                  case 2:
                     $img = @imagecreatefromjpeg($value);
                     break;

                  case 3:
                     $img = @imagecreatefrompng($value);
                     break;

                  case 15:
                     $img = @imagecreatefromwbmp($value);
                     break;

                  default:
                     $img = false;
                     break;
            }
        }

        if(!$img)
        {
            $size = $this->getImageSize();
            $img = imagecreatetruecolor($size['width'], $size['height']);
            imagefilledrectangle($img, 0, 0, $size['width'] - 1, $size['height'] - 1, $this->_getBackgroundColor());

            if(isset($this->_params['maptcha']) && $this->_params['maptcha'] == true)
            {
                $this->_drawBackgroundGrid($img);
            }
            else
            {
                $this->_drawBackgroundLines($img);
            }
        }

        return $img;
    }

    function _drawBackgroundGrid($image)
    {
        $step = 10;
        $size = $this->getImageSize();

        // Draw horizontal lines
        for($i = 1; $i < (($size['height']-1) / $step); $i++)
        {
            imageline($image, 0, $i*$step, $size['width'], $i*$step, $this->_getFontColor());
        }

        // Draw vertical lines
        for($i = 1; $i < (($size['width']-1) / $step); $i++)
        {
            imageline($image, $i*$step, 0, $i*$step, $size['height'], $this->_getFontColor());
            //imagedashedline($image, $i*$step, 0, $i*$step, $size['height'], $this->_getFontColor());
        }
    }

    function _drawBackgroundLines($image)
    {
        $linesMinCount = 30;
        $linesMaxCount = 120;
        $linesCount = rand($linesMinCount, $linesMaxCount);
        $lineMaxThickness = 5;
        $size = $this->getImageSize();
        for($i = 1; $i < $linesCount; $i++)
        {
            $x1 = rand(0, $size['width']);
            $y1 = rand(0, $size['height']);
            $x2 = rand(0, $size['width']);
            $y2 = rand(0, $size['height']);
            if(rand(0,1) == 1)
            {
                $color = imagecolorallocate(imagecreatetruecolor(1, 1), rand(1,255), rand(1,255), rand(1,255));
            }
            else
            {
                $color = $this->_getFontColor();
            }
            imagesetthickness($image, rand(1, $lineMaxThickness));
            //imageline($image, $x1, $y1, $x2, $y2, $color);
            rand(0,1) == 1 ? imagedashedline($image, $x1, $y1, $x2, $y2, $color) : imageline($image, $x1, $y1, $x2, $y2, $color);
        }
        //imagegammacorrect($image, 1.0, 0.2);
        //imagelayereffect($image, IMG_EFFECT_OVERLAY);
    }

    function _drawBackgroundLines2($image) // Will be used in future release
    {
//DebugBreak();
            $step = 10;
            $size = $this->getImageSize();

            // Draw lines
            for($i = 1; $i < (($size['height']-1) / $step); $i++)
            {
                //Draw line having width = x
                $lineThick = rand(1, 3);

                $x1 = 0;
                $y1 = ($i * $step) - $lineThick;
                $x2 = $size['width'];
                $y2 = $i * $step;

                imagefilledrectangle($image, $x1, $y1, $x2, $y2, $this->_getFontColor());
            }

            for($i = 1; $i < $size['width']; $i++)
            {
                $tmpOffset = ($i * rand(0, $i)) * (-1);
                imageline($image, $i, ($tmpOffset * $i) + rand(0, $i), rand($i * $step, $size['height']), ($size['width'] + rand(0, $step)), $this->_getFontColor());

                imagepolygon($image, array(0, 0, 100, 200, 300, 200), 3, $this->_getFontColor());
                imagepolygon($image, array(67, 16, 101, 201, 301, 201), 3, $this->_getFontColor());
            }
    }

    function _drawBackgroundLines3($image)// Will be used in future release
    {
        $arcsMinCount = 130;
        $arcsMaxCount = 180;
        $arcsCount = rand($arcsMinCount, $arcsMaxCount);
        $arcMaxThickness = 15;
        $size = $this->getImageSize();
        for($i = 1; $i < $arcsCount; $i++)
        {
            $cx = rand(1, $size['width']);
            $cy = rand(1, $size['height']);
            $width = rand(1, $size['width']);
            $height = rand(1, $size['height']);
            $start = rand(0, 360);
            $end = rand($start, 360);
            //$color =  imagecolorallocate(imagecreatetruecolor(1, 1), rand(1,255), rand(1,255), rand(1,255));
            $color =  imagecolorallocate(imagecreatetruecolor(1, 1), 0, 0, 0);
            imagesetthickness($image, rand(1, $lineMaxThickness));
            imagearc($image, $cx, $cy, $width, $height, $start, $end, $color);
        }


    }

    function _getTextLength()
    {
        return ((integer) $this->_params["text_length"]) ? $this->_params["text_length"] : 4;
    }

}
?>
